#ifndef CHROMEOS_CAMERA_LIB_BLAZEFACE_BLAZEFACE_CLIENT_CROS_WRAPPER_H_
#define CHROMEOS_CAMERA_LIB_BLAZEFACE_BLAZEFACE_CLIENT_CROS_WRAPPER_H_

#include <cstdint>
#include <memory>
#include <string>
#include <vector>

namespace mediapipe {

class CalculatorGraph;
class OutputStreamPoller;
class GlCalculatorHelper;

}

namespace human_sensing {

class CrosFace;

}

namespace cros {

class BlazefaceClientCrosWrapper {
 public:
  explicit BlazefaceClientCrosWrapper(bool use_gpu = false);
  ~BlazefaceClientCrosWrapper();

  // Returns true if initialized successfully.
  bool Initialize(const std::string& graph_file);

  // Returns true if detecting faces successfully even there is no face.
  // |data| is the address of an RGB image.
  bool Detect(
      const uint8_t* data, int width, int height,
      std::vector<human_sensing::CrosFace>* cros_faces);

 private:
  std::unique_ptr<mediapipe::CalculatorGraph> graph_;
  std::unique_ptr<mediapipe::OutputStreamPoller> poller_;
  std::unique_ptr<mediapipe::GlCalculatorHelper> gpu_helper_;
  bool use_gpu_ = false;
};

}  // namespace cros
#endif  // CHROMEOS_CAMERA_LIB_BLAZEFACE_BLAZEFACE_CLIENT_CROS_WRAPPER_H_
